from typing import Final, Dict, Any, TypeVar, Type
from .generic import Device, NoResponseError
from .sensor_wired_IAQ import SensorWiredIAQ
from .sensor_wired_RHT import SensorWiredRHT

# links device identifiers to its class
DEVICE_IDENTIFIERS: Final[Dict[int, Device]] = {
    SensorWiredIAQ.DEVICE_CODE: SensorWiredIAQ,
    SensorWiredRHT.DEVICE_CODE: SensorWiredRHT,
}

T = TypeVar("T", bound=Device)

def find_devices(device_cls: Type[T], address_space: list[Any]) -> list[T]:
    """
    Look for devices in given address space
    """
    # found_devices = []
    # for address in address_space:
    #     try:
    #         found_devices.append(device_cls(address))
    #     except NoResponseError:
    #         pass
    # return found_devices

    return list(filter(device_cls.probe, address_space))

    # TODO add device args
    # TODO return devices themselves, not addresses
    # TODO add .address to Device
